/*
-- ========================================================================== --
-- SISTEMA         : COMERCIAL COMISSARIA                                     --
-- DATA DA CRIAO : INCIO - 26/03/2012                                      --
-- PROGRAMADOR     : WILLIAM AZEVEDO DE PAULA                                 --
-- OBJETIVOS       : - GERAO DA PREVISO DE CONSUMO DO SISTEMA COC          --
--                                                                            --
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--  As Excesses encontram-se no formato:                                     --
--    '?'||Mensagem(12 caracteres)||Objeto com Erro ||'-'||Descricao/nome do  --
--    objeto com erro||''                                                    --
--							                      --	 
--	                          	  ou                      	      --	
--									      --	
--     '' ||Mensagem(10 caracteres)					      --	
-- ========================================================================== --
-- @C:\WIN_PRJ\SQL\END_CONV\ORACLE\2711_PREVISAO_CONSUMO_COC.sql
-- ========================================================================== --
*/

create or replace
PROCEDURE PREVISAO_CONSUMO_COC(
    P_CDFILIAL      IN VARCHAR2,
    P_LISTACIA      IN VARCHAR2,
     --Lista de CIAS. Formato: '_CDCIA1_CDCIA2_CDCIA3_'
    P_TCDCIA        IN VARCHAR2,
    P_CDPRODINI     IN VARCHAR2,
    P_CDPRODFIN     IN VARCHAR2,
    P_TCDPRODUTO    IN VARCHAR2,
    P_DATAINI       IN DATE,
    P_DATAFIN       IN DATE,
    P_IDTPPREVCONS  IN VARCHAR2,
    -- 'H' ('Historico'), 'M' ('Mxima'), 'P' ('Percentual de Ocupao')
    P_CDOPERPREVCONS IN VARCHAR2
)AS
  --===================DECLARAO DE VARIVEIS======================
    V_DATA_VOO      DATE;    
    V_COUNTPREVPAX  FLOAT;
    V_COUNTSUBGRU   FLOAT;
    V_BOPRODUTO     BOOLEAN;
    V_BORECEITA     BOOLEAN;
    V_SUBGRUANT     PRODUTO.CDPRODUTO%TYPE;
    V_QTSERVEXIST   FLOAT;
    V_CDESPEPROD    ESPEPROD.CDESPEPROD%TYPE;
    V_ARVRECORI     PRODUTO.CDARVPROD%TYPE;
    V_DESCRECORI    PRODUTO.NMPRODUTO%TYPE;
    V_CICLO_VIGENTE CIAFILI.CDCICLO%TYPE;  
    V_QTSESOLICSP   FLOAT;
    V_FILIA_CIA_ANT VARCHAR2(10);
    V_MANUAL        MANUALCIA.CDMANCIA%TYPE;
    V_CONTA_TCOMPRO FLOAT;
    V_CDTIPOCOMP    TCOMPPRO.CDTIPOCOMP%TYPE;
    V_COUNT_PROD_SUBREC FLOAT; 
    V_TESTAREPETE   INTEGER;
    V_CDARVSERV     PRODUTO.CDARVPROD%TYPE;
    V_DSSERVICO     PRODUTO.NMPRODUTO%TYPE;
    V_ARVSUBGRU     PRODUTO.CDARVPROD%TYPE;
    V_DESCSUBGRU    PRODUTO.NMPRODUTO%TYPE;
    V_COUNT_PRODUTO  FLOAT;
    V_CONTA_APROVADA FLOAT;
    
    C_CDFILIAL      FILIAL.CDFILIAL%TYPE;
    C_CDCIA         COMPANHIA.CDCIA%TYPE;
    C_NRVOO         VOOTRECHO.NRVOO%TYPE;
    C_CDTRECHO      VOOTRECHO.CDTRECHO%TYPE;
    C_CDBASEORI     VOOTRECHO.CDBASEORI%TYPE;
    C_CDBASEDES     VOOTRECHO.CDBASEDES%TYPE;
    C_HRPRODVOO     VARCHAR2(5);
    C_HRDECOLVOO    VARCHAR2(5);
    C_DTDECOLVOO    DATE;
    C_VRPEROCUPACAO FLOAT;
    C_QTDIASPROD    FLOAT;
    C_NRTURNOPROD   TURNO.NRTURNO%TYPE;       
    C_CDCLASSE      CLASSE.CDCLASSE%TYPE;
    C_QTTOTPAX      PREVPAXSRVTEMP.QTTOTPAXATPPT%TYPE;
    C_QTPAXSBY      PREVPAXSRVTEMP.QTPAXSBYPPT%TYPE;
    C_CDSERVICO     PRODUTO.CDPRODUTO%TYPE; 
    C_NRPROPAX      PAD_VOOPREFEQUI.NRPROPAX%TYPE;
    C_VRLOADSE      PAD_VOOPREFEQUI.VRLOADSE%TYPE;
    C_IDTIPMANUAL   PAD_VOOPREFEQUI.IDTIPMANUAL%TYPE;
    C_IDFATSE       PAD_VOOPREFEQUI.IDFATSE%TYPE;
    C_VRPESOSE      PAD_VOOPREFEQUI.VRPESOSE%TYPE;
    C_QTSESTBY      PAD_VOOPREFEQUI.QTSESTBY%TYPE;
    C_QTSERV        PAD_VOOPREFEQUI.QTSERV%TYPE;
    C_SGPREFIXO     PAD_VOOPREFEQUI.SGPREFIXO%TYPE;
    C_IDTPPRECO     PAD_VOOPREFEQUI.IDTPPRECO%TYPE;
    C_CDEQUIP       PAD_VOOPREFEQUI.CDEQUIP%TYPE;
    C_CDCICLO       PAD_VOOPREFEQUI.CDCICLO%TYPE;
    C_IDPROPSERV    PAD_VOOPREFEQUI.IDPROPSERV%TYPE;
    C_CICLO_UNICO   CIAFILI.CDCICLO%TYPE;  
    C_QTTOTSERVICO  FLOAT;
    C_CDSUBGRU      PRODUTO.CDPRODUTO%TYPE;
    C_CDPRODUTO     PRODUTO.CDPRODUTO%TYPE;
    C_QTPRODUTO     FLOAT;
    C_IDTPPROD      VARCHAR2(1);
    C_VRLOADSUMA    FLOAT;
    C_CDRECEITA     PRODUTO.CDPRODUTO%TYPE;
    C_QTRECEITA     FLOAT;
    C_CDPRODREC     PRODUTO.CDPRODUTO%TYPE;
    C_QTPRODREC     FLOAT;
    C_ORIGEM        VARCHAR2(1);
    
    
--===================DECLARAO DE CURSORES=======================

  --Armazena todos os VOO/Trecho que decolam na data informada (V_DATA_VOO) 
  CURSOR C_VOOS_DISP IS
  SELECT VT.CDCIA,
       VT.NRVOO,VT.CDTRECHO,
       VT.CDBASEORI, VT.CDBASEDES,       
       SUBSTR(VT.HRDECOLVOO,1,2)||':'||NVL(SUBSTR(VT.HRDECOLVOO,3,2),'00') HRPRODVOO,
       SUBSTR(VT.HRDECOLVOO,1,2)||':'||NVL(SUBSTR(VT.HRDECOLVOO,3,2),'00') HRDECOLVOO,
       TO_DATE(V_DATA_VOO) DTDECOLVOO,
       DECODE(NVL(VO.VRPEROCUPACAO,0),0,NVL(CF.VRPERCONVOO,0),NVL(VO.VRPEROCUPACAO,0)) AS VRPEROCUPACAO,
       VO.QTDIASPROD,VO.NRTURNOPROD 
  FROM VOOTRECHO VT, CIAFILI CF, COMPANHIA CO,TURNO TU,
     BASE BO, BASE BD,
     (SELECT CDCIA,NRVOO,IDTIPVOO,VRPEROCUPACAO,QTDIASPROD,NRTURNOPROD
      FROM VOO
      WHERE (CDFILIAL  = P_CDFILIAL) AND
            (IDSITVOO  = '1'        ) AND
            ((IDTIPVOO  = '1'        ) OR
             ((IDTIPVOO  = '2'        ) AND
              (V_DATA_VOO BETWEEN DTINIVIGVOO AND DTFIMVIGVOO)))AND
              ((P_TCDCIA = 'T')OR(INSTR(P_LISTACIA,VOO.CDCIA) > 0)) AND
            (IDVOODOM||IDVOOSEG||IDVOOTER||IDVOOQUA||
             IDVOOQUI||IDVOOSEX||IDVOOSAB LIKE
             SUBSTR(LPAD('1',TO_CHAR(V_DATA_VOO,'D'),'_'),1,7)||'%')) VO
  WHERE (CF.CDFILIAL    = P_CDFILIAL ) AND
      (VT.CDFILIAL    = P_CDFILIAL ) AND
      (VT.CDCIA       = CF.CDCIA    ) AND
      (VT.NRVOO       = VO.NRVOO    ) AND
      (VT.IDSITVOOTRE = '1'         ) AND
      (VO.CDCIA       = CF.CDCIA    ) AND
      (CO.CDCIA       = CF.CDCIA    ) AND
      (BO.CDBASE      = VT.CDBASEORI) AND
      (BD.CDBASE      = VT.CDBASEDES) AND
      (TU.NRTURNO(+)     = VO.NRTURNOPROD ) AND
      ((P_TCDCIA = 'T')OR(INSTR(P_LISTACIA,CO.CDCIA) > 0))
  ORDER BY
      CO.SGCIA,VT.NRVOO,BO.SGBASE,BD.SGBASE;
      
  --  retorna todas as previses de passageiros geradas dentro do  cursor C_VOOS_DISP.
 CURSOR C_PREV_PAX IS
  SELECT PV.CDFILIAL,PV.CDCIAPPT,PV.NRVOOPPT,PV.CDTRECHOPPT,PV.DTHRPLAPPT,PV.CDCLASSEPPT,
        PV.QTTOTPAXATPPT,PV.QTPAXSBYPPT,PV.CDEQUIPPPT,PV.SGPREFIXOPPT,PA.CDSERVICO,
          PA.NRPROPAX,PA.VRLOADSE , PA.IDTIPMANUAL, PA.IDFATSE,
          PA.VRPESOSE , PA.QTSESTBY   , PA.QTSERV,PA.SGPREFIXO, PA.IDTPPRECO  , PA.CDEQUIP,
          PA.CDCICLO  , PA.IDPROPSERV ,CF.CDCICLO AS CICLO_UNICO
         
  FROM PREVPAXSRVTEMP PV,PAD_VOOPREFEQUI PA,CIAFILI CF
  WHERE
     (PV.IDTPGERPPT = 'C'     ) AND     
     (PA.CDFILIAL = PV.CDFILIAL   ) AND
     (PA.CDCIA    = PV.CDCIAPPT   ) AND
     (PA.NRVOO    = PV.NRVOOPPT   ) AND
     (PA.CDTRECHO = PV.CDTRECHOPPT) AND
     (PA.CDCLASSE = PV.CDCLASSEPPT) AND
     (PA.IDSITSERVICO = '1'       ) AND
     (CF.CDFILIAL(+) = PA.CDFILIAL) AND
     (CF.CDCIA   (+) = PA.CDCIA   ) AND
     (PV.DTHRPLAPPT = V_DATA_VOO  ) AND
     (PV.CDFILIAL = P_CDFILIAL    ) AND
     ((P_TCDCIA = 'T')OR(INSTR(P_LISTACIA,PV.CDCIAPPT) > 0)) 
  ORDER BY PV.CDFILIAL,PV.CDCIAPPT,PV.NRVOOPPT,PV.CDTRECHOPPT,PV.CDCLASSEPPT,PA.CDSERVICO;
  
  
  --Agrupa todos os servios da tabela temporaria, com as quantidades nos voos somadas 
  CURSOR C_SERVICO IS
  SELECT S.CDFILIAL,S.CDCIA,S.NRVOO,S.CDTRECHO,S.DTDECOLVOO,S.CDCLASSE,S.CDCICLO,S.CDPRODUTO,SUM(S.QTSERVICO) AS QTTOTSERVICO 
  FROM SERVPREVCONSTMP S
  WHERE
    (CDFILIAL = P_CDFILIAL      ) AND
    (S.DTDECOLVOO = V_DATA_VOO  ) AND
    (S.IDTPPROD = 'S'           ) AND
    (P_TCDCIA = 'T')OR(INSTR(P_LISTACIA,S.CDCIA) > 0)     
  GROUP BY S.CDFILIAL, S.CDCIA, S.CDCLASSE,S.NRVOO,S.CDTRECHO,S.DTDECOLVOO, S.CDCICLO, S.CDPRODUTO
  ORDER BY S.CDFILIAL, S.CDCIA,S.NRVOO,S.CDTRECHO,S.DTDECOLVOO, S.CDCLASSE,S.CDPRODUTO;
  
  
  --Cursor para buscar os subgrupos de um servio, juntamente com seus produtos e receitas
  CURSOR C_SUBGRU_PROD_REC IS
  SELECT
      CDSUBGRU,CDPRODUTO,QTPRODUTO,IDTPPROD,VRLOADSUMA
  FROM 
      (
         
      SELECT  C_CDSERVICO AS CDSERVICO,PE.CDARVPROD AS CDARVSERVICO, SU.CDSUBGRU,PR.CDARVPROD AS CDARVSUBGRU,
                  PS.CDPRODUTO,PS.QTPRODSUMA AS QTPRODUTO,PT.NMPRODUTO,
                  'P' AS IDTPPROD, PT.CDARVPROD,PS.VRLOADPSUMA AS VRLOADSUMA
      FROM PRODSUBSEMA PS, PRODUTO PT,SUBGRUSEMA SU, SUBGRUPO SG,PRODUTO PR, ESPEPROD EP,COMPPROD CP,PRODUTO PE
      WHERE (PS.CDCIA    (+) = SU.CDCIA       ) AND
            (PS.CDFILIAL (+) = SU.CDFILIAL    ) AND
            (PS.CDMANCIA (+) = SU.CDMANCIA    ) AND
            (PS.CDSERVICO(+) = SU.CDSERVICO   ) AND
            (PS.CDSUBGRU (+) = SU.CDSUBGRU    ) AND
            (PS.CDCLASSE (+) = SU.CDCLASSE    ) AND
            (PS.CDCICLO  (+) = SU.CDCICLO     ) AND
            (PS.CDPRODUTO    = PT.CDPRODUTO(+)) AND
            (SU.CDCIA        =   C_CDCIA      ) AND
            (SU.CDFILIAL     =   C_CDFILIAL   ) AND
            (SU.CDMANCIA     =   V_MANUAL     ) AND
            (SU.CDSERVICO    =   C_CDSERVICO  ) AND
            (SU.CDCLASSE     =   C_CDCLASSE   ) AND
            (SU.CDCICLO      =   C_CDCICLO    ) AND
            (SU.CDSUBGRU     = SG.CDSUBGRU    ) AND
            (SG.CDSUBGRU     = PR.CDPRODUTO   ) AND         
            (CP.CDESPEPROD   = EP.CDESPEPROD  ) AND
            (CP.CDPRODUTO    = SU.CDSERVICO   ) AND
            (CP.CDPRODINSUMO = SU.CDSUBGRU    ) AND
            (EP.IDTPMANUAL   = 'M'            ) AND
            (EP.CDFILIAL     = SU.CDFILIAL    ) AND
            (EP.CDCIA        = SU.CDCIA       ) AND
            (EP.CDMANCIA     = SU.CDMANCIA    ) AND
            (SU.CDSERVICO    = EP.CDPRODUTO   ) AND
            (PE.CDPRODUTO    = SU.CDSERVICO   ) 
          --AND            
          --  ((P_TCDPRODUTO = 'T')OR(PT.CDARVPROD(+) BETWEEN  P_CDPRODINI AND P_CDPRODFIN))
         
         
      UNION ALL
         
      SELECT  C_CDSERVICO AS CDSERVICO,PE.CDARVPROD AS CDARVSERVICO, SU.CDSUBGRU,PR.CDARVPROD AS CDARVSUBGRU,
           RE.CDRECEITA AS CDPRODUTO,RS.QTRECSUMA AS QTPRODUTO,RE.DSRECEITA AS NMPRODUTO,
                 'R' AS IDTPPROD,RE.CDARVREC AS CDARVPROD,RS.VRLOADRSUMA AS VRLOADSUMA
      FROM RECSUBSEMA RS, RECEITA RE,SUBGRUSEMA SU, SUBGRUPO SG,PRODUTO PR, ESPEPROD EP,COMPPROD CP,PRODUTO PE
      WHERE (RE.CDRECEITA(+)     = RS.CDRECEITA      ) AND
            (RS.CDCIA    (+)  = SU.CDCIA          ) AND
            (RS.CDFILIAL (+)  = SU.CDFILIAL       ) AND
            (RS.CDMANCIA (+)  = SU.CDMANCIA       ) AND
            (RS.CDSERVICO(+)  = SU.CDSERVICO      ) AND
            (RS.CDCLASSE (+)  = SU.CDCLASSE       ) AND
            (RS.CDCICLO  (+)  = SU.CDCICLO        ) AND
            (RS.CDSUBGRU (+)  = SU.CDSUBGRU       ) AND
            (SU.CDCIA        =   C_CDCIA      ) AND
            (SU.CDFILIAL     =   C_CDFILIAL   ) AND
            (SU.CDMANCIA     =   V_MANUAL     ) AND
            (SU.CDSERVICO    =   C_CDSERVICO  ) AND
            (SU.CDCLASSE     =   C_CDCLASSE   ) AND
            (SU.CDCICLO      =   C_CDCICLO    ) AND
            (SU.CDSUBGRU     = SG.CDSUBGRU    ) AND
            (SG.CDSUBGRU     = PR.CDPRODUTO   ) AND         
            (CP.CDESPEPROD   = EP.CDESPEPROD  ) AND
            (CP.CDPRODUTO    = SU.CDSERVICO   ) AND
            (CP.CDPRODINSUMO = SU.CDSUBGRU    ) AND
            (EP.IDTPMANUAL   = 'M'            ) AND
            (EP.CDFILIAL     = SU.CDFILIAL    ) AND
            (EP.CDCIA        = SU.CDCIA       ) AND
            (EP.CDMANCIA     = SU.CDMANCIA    ) AND
            (SU.CDSERVICO    = EP.CDPRODUTO   ) AND
            (PE.CDPRODUTO    = SU.CDSERVICO    )
      )
      ORDER BY CDSUBGRU,CDPRODUTO;   
      
      
      
     --Cursor para buscar as receitas que esto na tabela temporria SERVPREVCONSTMP 
     CURSOR C_RECEITAS IS 
     SELECT CDPRODUTO,QTSERVICO 
     FROM SERVPREVCONSTMP
      WHERE 
       (CDFILIAL   = C_CDFILIAL)  AND
       (CDCIA      = C_CDCIA   )  AND
       (NRVOO      = C_NRVOO   )  AND
       (CDTRECHO   = C_CDTRECHO)  AND
       (CDCLASSE   = C_CDCLASSE) AND
       (DTDECOLVOO = C_DTDECOLVOO) AND
       (IDTPPROD = 'R')
       
      ORDER BY 
      CDFILIAL,CDCIA,NRVOO,CDTRECHO,CDCLASSE,CDPRODUTO,CDCICLO;
      
      
      --Cursor para buscar os Produtos e as Subreceitas que compem uma receita/subreceita
      CURSOR PROD_SUBREC IS
      SELECT 
           PR.CDPRODUTO,PR.QTPRODSUMA,PR.ORIGEM         
      FROM 
         (         
         SELECT  PR.CDPRODUTO,CP.QTINSUMO/EP.QTPADESPEPRO AS QTPRODSUMA,'P' AS ORIGEM
         FROM COMPPROD CP, PRODUTO PR, TIPOINSU TI, ESPEPROD EP
          WHERE (CP.CDPRODUTO    = C_CDRECEITA  ) AND
          (CP.CDESPEPROD   = V_CDESPEPROD       ) AND
          (CP.CDTIPOCOMP   = V_CDTIPOCOMP       ) AND
          (CP.CDPRODINSUMO = PR.CDPRODUTO       ) AND
          (CP.CDTIPOINSU   = TI.CDTIPOINSU(+)   ) AND
          (CP.CDPRODUTO     = EP.CDPRODUTO      ) AND
          (CP.CDESPEPROD    = EP.CDESPEPROD     ) AND
          (PR.IDPRODCOMISS IS NULL              )          
          UNION ALL                
          SELECT PR.CDPRODUTO,CP.QTINSUMO/EP.QTPADESPEPRO AS QTPRODSUMA,'R' AS ORIGEM
          FROM COMPPROD CP, PRODUTO PR, TIPOINSU TI, ESPEPROD EP
          WHERE (CP.CDPRODUTO    = C_CDRECEITA     ) AND
                (CP.CDESPEPROD   = V_CDESPEPROD    ) AND
                (CP.CDTIPOCOMP   = V_CDTIPOCOMP    ) AND
                (CP.CDPRODINSUMO = PR.CDPRODUTO    ) AND
                (CP.CDTIPOINSU   = TI.CDTIPOINSU(+)) AND
                (CP.CDPRODUTO     = EP.CDPRODUTO   ) AND
                (CP.CDESPEPROD    = EP.CDESPEPROD  ) AND
                (PR.IDPRODCOMISS = '3')          
        )  PR
       ORDER BY ORIGEM,CDPRODUTO;
       
       
       --Busca todos os Produtos da Tabela temporria, com as quantidades somadas (Qt. Total)
       CURSOR C_PRODUTOS IS
       SELECT S.CDFILIAL,S.CDCIA,S.CDPRODUTO,SUM(S.QTSERVICO)
        FROM SERVPREVCONSTMP S,PRODUTO PT
        WHERE
          (PT.CDPRODUTO = S.CDPRODUTO) AND
          (S.CDFILIAL = C_CDFILIAL   ) AND
          (S.IDTPPROD = 'P'          ) AND          
          ((P_TCDPRODUTO = 'T')OR(PT.CDARVPROD BETWEEN  P_CDPRODINI AND P_CDPRODFIN))
        group by S.CDFILIAL, S.CDCIA, S.CDPRODUTO
        ORDER BY S.CDFILIAL,S.CDPRODUTO;
      



   
--==============================================================================     
BEGIN

   --Apaga todos os dados da tabela temporria
   DELETE FROM SERVPREVCONSTMP;   
  
  -------------------------------------------------------------------------------
  --   Percorrer todos os dias dentro do perodo informado (parmetros P_DATAINI 
  --   e P_DATAFIN) e realizar a rotina inteira para cada um teles
  -------------------------------------------------------------------------------
  V_DATA_VOO := P_DATAINI;
  WHILE (V_DATA_VOO <= P_DATAFIN ) LOOP
  
  
  
     ------------------------------------------------------------------------------
     --  Buscar todos os vos que decolam no dia, e gera a previso de passageiros
     --  para os mesmos, na tabela PREVPAXSRVTEMP
     ------------------------------------------------------------------------------
     
     --Percorre todos os voos da data, inserindo eles na tabela temporria VOOS_DISP_TMP
     OPEN C_VOOS_DISP;
     LOOP
        FETCH C_VOOS_DISP INTO C_CDCIA,C_NRVOO,C_CDTRECHO,C_CDBASEORI,C_CDBASEDES,C_HRPRODVOO,
                             C_HRDECOLVOO,C_DTDECOLVOO,C_VRPEROCUPACAO,C_QTDIASPROD,C_NRTURNOPROD;
        EXIT WHEN C_VOOS_DISP%NOTFOUND;

        
        ----------------------------------------------------------------------------
        --  Verifica, peimeiramente, se h Previso de passageiros para alguma
        --  classe do voo. Se houver, no  gerada uma nova previsao (de forma
        --  que classes que tenham sido includas aps a primeira gerao
        --  continuaro fora da previso). Procura-se previses de pax do tipo 'C',
        --  isto , 'Previsao de Consumo'.        
        ----------------------------------------------------------------------------
        SELECT COUNT(*)  INTO V_COUNTPREVPAX
        FROM PREVPAXSRVTEMP
        WHERE
         CDFILIAL    =  P_CDFILIAL   AND
         CDCIAPPT    =  C_CDCIA      AND
         NRVOOPPT    =  C_NRVOO      AND
         CDTRECHOPPT =  C_CDTRECHO   AND
         DTHRPLAPPT  =  C_DTDECOLVOO AND
         IDTPGERPPT  =  'C';
        
         
        IF V_COUNTPREVPAX = 0  THEN      
                
           ------------------------------------------------------------------------------------------------------------------------
           --  Gera Previso de Passageiros para o Voo (O P_TIPPREVISAO, inicialmente  '1' (criao de previso zerada com insert
           --  na Prevpaxtemp ) e P_SIMULACAO = '2' (para Programao de servios, e no lano de voo. Dessa forma, o insert
           --   na PREVPAXSRVTEMP, e no na PREVPAXTEMP). Em seguida, a previso  regerada, ajustando as quantidades de 
           --  acordo com o tipo de previso selecionado (parmetro P_IDTPPREVCONS)
           -------------------------------------------------------------------------------------------------------------------------
           GERA_PREVISAO_PAX(P_CDFILIAL,SYSDATE,'',C_CDCIA,C_NRVOO,C_CDTRECHO,C_DTDECOLVOO,'1','C',C_VRPEROCUPACAO,'2','','','');
        END IF;
      
        --Histrico
        IF P_IDTPPREVCONS = 'H' THEN 
             --Regera a Previso, porm com P_TIPPREVISAO = '2' (Histrico de Ocupao)
           GERA_PREVISAO_PAX(P_CDFILIAL,SYSDATE,'',C_CDCIA,C_NRVOO,C_CDTRECHO,C_DTDECOLVOO,'2','C',C_VRPEROCUPACAO,'2','','','');      
        --Mxima
        ELSIF P_IDTPPREVCONS = 'M' THEN  
            --Regera a Previso, porm com P_TIPPREVISAO = '3' (Ocupao Mxima)
             GERA_PREVISAO_PAX(P_CDFILIAL,SYSDATE,'',C_CDCIA,C_NRVOO,C_CDTRECHO,C_DTDECOLVOO,'3','C',C_VRPEROCUPACAO,'2','','','');
        --Percentual de ocupao             
        ELSIF P_IDTPPREVCONS = 'P' THEN 
             --Regera a Previso, porm com P_TIPPREVISAO = '6' (Percentual de Ocupao)
             GERA_PREVISAO_PAX(P_CDFILIAL,SYSDATE,'',C_CDCIA,C_NRVOO,C_CDTRECHO,C_DTDECOLVOO,'6','C',C_VRPEROCUPACAO,'2','','','');
        END IF;
                        
     END LOOP;
     CLOSE C_VOOS_DISP; 
  
  
  
      
      
      -------------------------------------------------------------------------------
      --  Buscar as previses de pax geradas e os servios das classes das mesmas,
      --  para poder gerar a previso de consumo
      -------------------------------------------------------------------------------
      OPEN C_PREV_PAX;
      LOOP
         FETCH C_PREV_PAX INTO C_CDFILIAL,C_CDCIA,C_NRVOO,C_CDTRECHO,C_DTDECOLVOO,C_CDCLASSE,
                               C_QTTOTPAX,C_QTPAXSBY,C_CDEQUIP,C_SGPREFIXO,C_CDSERVICO,
                               C_NRPROPAX,C_VRLOADSE , C_IDTIPMANUAL, C_IDFATSE,
                               C_VRPESOSE , C_QTSESTBY   , C_QTSERV,C_SGPREFIXO, C_IDTPPRECO  , C_CDEQUIP,
                               C_CDCICLO  , C_IDPROPSERV ,C_CICLO_UNICO;
         EXIT WHEN C_PREV_PAX%NOTFOUND;
         
         -- Busca o Ciclo vigente. (o parmetro de sada e V_CICLO_VIGENTE);
         V_CICLO_VIGENTE := C_CDCICLO;
         RETORNA_CICLO(C_CDFILIAL,C_CDCIA,C_NRVOO,C_CDTRECHO,C_DTDECOLVOO,C_CDSERVICO,C_CDCLASSE,V_CICLO_VIGENTE);
         
         -- O ciclo do servio deve ser igual ao ciclo vigente ou ao ciclo nico (a sada utilizada  V_QTSESOLICSP)
         IF (C_CDCICLO = V_CICLO_VIGENTE)OR(C_CDCICLO = C_CICLO_UNICO) THEN
            -- Calcula a Quantidade do servio. 
            CALCULA_QUANTIDADES(C_CDFILIAL,C_CDCIA,C_NRVOO,C_CDTRECHO,C_CDSERVICO,C_CDCLASSE,C_CDCICLO,
                                C_QTTOTPAX+C_QTPAXSBY,C_IDPROPSERV,C_VRLOADSE,C_NRPROPAX,C_QTSERV,V_QTSESOLICSP, C_QTSESTBY);
            
            
            --Se o tipo de proporo for fixo e houver quantidade fixa cadastrada, utiliza a quantidade fixa
            IF (C_IDPROPSERV = '5') AND (C_QTSERV > 0) THEN 
               V_QTSESOLICSP := C_QTSERV;
            END IF;
            
            --Se houver quantidade a ser produzida, Insere o servio na tabela temporria
            IF V_QTSESOLICSP > 0 THEN
               INSERT INTO SERVPREVCONSTMP
                  (CDFILIAL,CDCIA,NRVOO,CDTRECHO,CDCLASSE,CDPRODUTO,CDCICLO,QTSERVICO,DTDECOLVOO,IDTPPROD)
               VALUES
                  (C_CDFILIAL,C_CDCIA,C_NRVOO,C_CDTRECHO,C_CDCLASSE,C_CDSERVICO,C_CDCICLO,V_QTSESOLICSP,C_DTDECOLVOO,'S');
            END IF;
         END IF;     
         
         
      END LOOP;
      CLOSE C_PREV_PAX;
      
 
      
      -------------------------------------------------------------------------------
      --  Buscar os servios da tabela temporria, com as quantidades j calculadas
      -------------------------------------------------------------------------------
      
      V_FILIA_CIA_ANT := ' ';
      OPEN C_SERVICO;
      LOOP 
         FETCH C_SERVICO INTO C_CDFILIAL,C_CDCIA,C_NRVOO,C_CDTRECHO,C_DTDECOLVOO,C_CDCLASSE,C_CDCICLO,C_CDSERVICO,C_QTTOTSERVICO;
         EXIT WHEN C_SERVICO%NOTFOUND;
         
         --Ocursor C_SERVICO esta agrupado por filial e cia. se uma das duas mudar...
         IF V_FILIA_CIA_ANT <> C_CDFILIAL||'-'||C_CDCIA THEN
            --Buscar o Manual da Produo vigente para a Filial-Companhia
            SELECT CDMANCIA 
            INTO V_MANUAL
            FROM MANUALCIA 
            WHERE 
              (CDCIA     = C_CDCIA    ) AND
              (CDFILIAL  = C_CDFILIAL ) AND
              (DTINIVGMA = (SELECT MAX(DTINIVGMA)
                           FROM MANUALCIA
                           WHERE
                              (CDCIA = C_CDCIA     )AND
                              (CDFILIAL = C_CDFILIAL) AND
                              (DTINIVGMA < SYSDATE  )                                                  
                          )
                                     
             ) AND
             (IDTPMANUAL = 'M'     );
             
             V_FILIA_CIA_ANT := C_CDFILIAL||'-'||C_CDCIA;
         END IF;    
          
          ----------------------------------------------------------------------------
          --    Buscar os Produtos e receitas, sendo os produtos salvos na tabela 
          --    temporria, aplicando-se o loading e multiplicados pela quantidade do
          --    servio.
          ----------------------------------------------------------------------------
          V_COUNTSUBGRU := 0;
          V_SUBGRUANT := ' ';
          OPEN C_SUBGRU_PROD_REC;
          LOOP
             FETCH C_SUBGRU_PROD_REC INTO C_CDSUBGRU,C_CDPRODUTO,C_QTPRODUTO,C_IDTPPROD,C_VRLOADSUMA;
             EXIT WHEN C_SUBGRU_PROD_REC%NOTFOUND;
             
             --Passou para o prximo subgrupo                 
             IF V_SUBGRUANT <> C_CDSUBGRU THEN 
                V_BOPRODUTO := TRUE;
                V_BORECEITA := TRUE;
                V_SUBGRUANT := C_CDSUBGRU;                                     
            END IF;
            IF  (C_IDTPPROD = 'P' AND C_CDPRODUTO IS NULL) THEN
                --Indica que o subgrupo atual no possui Produtos
                V_BOPRODUTO := FALSE; 
            ELSIF (C_IDTPPROD = 'R' AND C_CDPRODUTO IS NULL) THEN
                --Indica que o subgrupo atual no possui Receitas
                V_BORECEITA := FALSE; 
            ELSE
               
               --Verifica se j existe quantidade para o produto na tabela temporria          
               BEGIN
                  SELECT QTSERVICO
                  INTO
                     V_QTSERVEXIST 
                  FROM 
                     SERVPREVCONSTMP
                  WHERE
                     (CDFILIAL   =  C_CDFILIAL  ) AND
                     (CDCIA      =  C_CDCIA     ) AND
                     (NRVOO      =  C_NRVOO     ) AND
                     (CDTRECHO   =  C_CDTRECHO  ) AND
                     (CDCLASSE   =  C_CDCLASSE  ) AND
                     (CDPRODUTO  =  C_CDPRODUTO ) AND   
                     (DTDECOLVOO =  C_DTDECOLVOO) AND
                     (IDTPPROD   =  C_IDTPPROD  );
               EXCEPTION
                    WHEN NO_DATA_FOUND THEN
                       V_QTSERVEXIST := 0;
                   
               END;
                 
                ----Se For Produto ou Receita e no houver qtde. Insere na tabela temporaria
                IF (V_QTSERVEXIST = 0) AND (((C_QTPRODUTO*C_VRLOADSUMA*C_QTTOTSERVICO)/100)>0) THEN
    
                             
                   INSERT INTO SERVPREVCONSTMP
                      (CDFILIAL,CDCIA,NRVOO,CDTRECHO,CDCLASSE,CDPRODUTO,CDCICLO,DTDECOLVOO,QTSERVICO,IDTPPROD)
                   VALUES
                     (C_CDFILIAL,C_CDCIA,C_NRVOO,C_CDTRECHO,C_CDCLASSE,C_CDPRODUTO,C_CDCICLO,C_DTDECOLVOO,
                     ((C_QTPRODUTO*C_VRLOADSUMA*C_QTTOTSERVICO)/100),C_IDTPPROD);
               
               ----Se For Produto ou Receita e  houver qtde. soma a qtde  ja existente na tabela temporaria
                ELSIF V_QTSERVEXIST > 0 THEN
                   UPDATE SERVPREVCONSTMP
                   SET    QTSERVICO = V_QTSERVEXIST + ((C_QTPRODUTO*C_VRLOADSUMA*C_QTTOTSERVICO)/100)
                   WHERE
                    (CDFILIAL   =  C_CDFILIAL  ) AND
                    (CDCIA      =  C_CDCIA     ) AND
                    (NRVOO      =  C_NRVOO     ) AND
                    (CDTRECHO   =  C_CDTRECHO  ) AND
                    (CDCLASSE   =  C_CDCLASSE  ) AND
                    (CDPRODUTO  =  C_CDPRODUTO ) AND   
                    (DTDECOLVOO =  C_DTDECOLVOO) AND
                    (IDTPPROD   =  C_IDTPPROD  );                
                END IF;
            END IF;
            
            --Se o subgrupo no possuir produtos nem receitas, retorna erro
            IF (NOT V_BOPRODUTO) AND (NOT V_BORECEITA) THEN 
              SELECT CDARVPROD,NMPRODUTO
              INTO V_ARVSUBGRU,V_DESCSUBGRU
              FROM PRODUTO
              WHERE
                CDPRODUTO = C_CDSUBGRU;
              
              RAISE_APPLICATION_ERROR( -20502, '?SubGruSPrdRc'||V_ARVSUBGRU||'-'||V_DESCSUBGRU||'', false);   
              
                 -- Gerao Interrompida. O subgrupo V_ARVSUBGRU || - ||V_DESCSUBGRU no possui nenhum produto 
                 -- ou receita em sua composio. Verifique o menu "Manual Aprovado -> Manual de Custos Aprovados" 
                 -- e tente novamente.*/

            END IF;
             V_COUNTSUBGRU := V_COUNTSUBGRU + 1;
          END LOOP;
          CLOSE C_SUBGRU_PROD_REC;
          
          --------------------------------------------------------------------------
          --    Substitui, recursivamente, todas as receitas da tabela temporria
          --    pelos produtos e receitas que a compem, at que no reste mais 
          --    nenhuma receita na tabela temporria.
          --------------------------------------------------------------------------
          V_TESTAREPETE := 1;
          WHILE (V_TESTAREPETE > 0) LOOP
                OPEN C_RECEITAS;
                
                --Apaga todas as receitas da tabla temporria
                DELETE FROM SERVPREVCONSTMP WHERE IDTPPROD = 'R'; 
          
                LOOP 
                   FETCH C_RECEITAS INTO C_CDRECEITA,C_QTRECEITA;
                   EXIT WHEN C_RECEITAS%NOTFOUND;
                
                
                
                    --Busca a Especificao tcnica vigente na data da produo        
                      BEGIN
                         SELECT CDESPEPROD 
                         INTO V_CDESPEPROD 
                          FROM ESPEPROD 
                          WHERE
                            CDPRODUTO = C_CDRECEITA AND
                            DTVALESPEPRO = (SELECT MAX(DTVALESPEPRO) FROM ESPEPROD WHERE 
                                            CDPRODUTO = C_CDRECEITA AND
                                            DTVALESPEPRO <= C_DTDECOLVOO);
                      EXCEPTION
                          WHEN NO_DATA_FOUND THEN
                            V_CDESPEPROD := NULL;  
                      END;                    
                      IF V_CDESPEPROD IS NULL THEN    
                        SELECT CDARVPROD,NMPRODUTO 
                        INTO V_ARVRECORI,V_DESCRECORI 
                        FROM PRODUTO 
                        WHERE CDPRODUTO = C_CDRECEITA;       
                           
                        RAISE_APPLICATION_ERROR( -20502, '?RecSemEspTec'||V_ARVRECORI||'-'||V_DESCRECORI||'', false);   
                            /*  Gerao Interrompida. A receita ||V_ARVRECORI||'-'||V_DESCRECOR|| no possui
                                especificao tcnica vigente na data de produo informada.*/
                      END IF;
                      
                      
                       --Verifica se h tipo de composio padro cadastrada
                        SELECT COUNT(*) 
                        INTO V_CONTA_TCOMPRO
                        FROM  TCOMPPRO 
                        WHERE
                          (CDPRODUTO  = C_CDRECEITA  ) AND
                          (CDESPEPROD = V_CDESPEPROD ) AND
                          (IDTCOMPPROC = 'S'         );
                      
                      
                      --Se houver um nico tipo de composio marcado com "Padro de OP", busca o mesmo 
                       IF V_CONTA_TCOMPRO = 1 THEN           
                           SELECT CDTIPOCOMP
                           INTO V_CDTIPOCOMP
                           FROM TCOMPPRO 
                           WHERE
                           (CDPRODUTO  = C_CDRECEITA  ) AND
                           (CDESPEPROD = V_CDESPEPROD ) AND
                           (IDTCOMPPROC = 'S');
                      --Se no tiver composio marcada como padro, retorna erro
                      ELSIF V_CONTA_TCOMPRO <= 0 THEN
                          SELECT CDARVPROD,NMPRODUTO 
                          INTO V_ARVRECORI,V_DESCRECORI 
                          FROM PRODUTO 
                          WHERE CDPRODUTO = C_CDRECEITA;      
                          
                          RAISE_APPLICATION_ERROR( -20502, '?RecSemComPad'||V_ARVRECORI||'-'||V_DESCRECORI||'', false);
                          
                          --  Gerao Interrompida. A receita ||V_ARVRECORI||'-'||V_DESCRECOR|| no possui
                          --  composio Padro para a especificao tcnica vigente.
                      
                      --Se houver mais de uma marcada como padro (inconsistncia no Banco), retorna erro
                      ELSIF V_CONTA_TCOMPRO > 1 THEN
                          SELECT CDARVPROD,NMPRODUTO 
                          INTO V_ARVRECORI,V_DESCRECORI 
                          FROM PRODUTO 
                          WHERE CDPRODUTO = C_CDRECEITA;      
                          
                          RAISE_APPLICATION_ERROR( -20502, '?RecVarComPad'||V_ARVRECORI||'-'||V_DESCRECORI||'', false);
                          
                          --  Gerao Interrompida. A receita ||V_ARVRECORI||'-'||V_DESCRECOR|| possui mais
                          --  de um tipo de composio marcado como "Padro de OP" para a especificao tcnica vigente.

                      END IF;                           
                     
                     
                      
                      
                      --------------------------------------------------------------------------
                      --   Busca os Produtos e receitas que compem  a receita. Se no retornar
                      --   dados (V_COUNT_PROD_SUBREC = 0), retorna erro, pois significa que a
                      --   receita no possui produtos nem receitas em sua composio
                      --------------------------------------------------------------------------
                      V_COUNT_PROD_SUBREC := 0;
                      OPEN PROD_SUBREC;
                      LOOP
                         FETCH PROD_SUBREC INTO C_CDPRODREC,C_QTPRODREC,C_ORIGEM;               
                         EXIT WHEN PROD_SUBREC%NOTFOUND;
                               
                             
                         --Verifica se j existe quantidade para o produto/receita na tabela temporria   
                         BEGIN
                             SELECT QTSERVICO
                             INTO
                                V_QTSERVEXIST 
                             FROM 
                                SERVPREVCONSTMP
                             WHERE
                                (CDFILIAL   =  C_CDFILIAL  ) AND
                                (CDCIA      =  C_CDCIA     ) AND
                                (NRVOO      =  C_NRVOO     ) AND
                                (CDTRECHO   =  C_CDTRECHO  ) AND
                                (CDCLASSE   =  C_CDCLASSE  ) AND
                                (CDPRODUTO  =  C_CDPRODREC ) AND   
                                (DTDECOLVOO =  C_DTDECOLVOO) AND
                                (IDTPPROD   =  C_ORIGEM  );
                         EXCEPTION
                            WHEN NO_DATA_FOUND THEN
                                V_QTSERVEXIST := 0;
                         END;
                            
                         ----Se For Produto ou Receita e no houver qtde. Insere na tabela temporaria
                         IF (V_QTSERVEXIST = 0) AND ((C_QTPRODREC*C_QTRECEITA)>0) THEN
                            INSERT INTO SERVPREVCONSTMP
                              (CDFILIAL,CDCIA,NRVOO,CDTRECHO,CDCLASSE,CDPRODUTO,CDCICLO,DTDECOLVOO,QTSERVICO,IDTPPROD)
                            VALUES
                              (C_CDFILIAL,C_CDCIA,C_NRVOO,C_CDTRECHO,C_CDCLASSE,C_CDPRODREC,C_CDCICLO,C_DTDECOLVOO,
                              (C_QTPRODREC*C_QTRECEITA),C_ORIGEM);
                           
                             ----Se For Produto ou Receita e  houver qtde. soma a qtde  ja existente na tabela temporaria
                         ELSIF V_QTSERVEXIST > 0 THEN
                               UPDATE SERVPREVCONSTMP
                               SET    QTSERVICO = V_QTSERVEXIST + (C_QTPRODREC*C_QTRECEITA)
                               WHERE
                                (CDFILIAL   =  C_CDFILIAL  ) AND
                                (CDCIA      =  C_CDCIA     ) AND
                                (NRVOO      =  C_NRVOO     ) AND
                                (CDTRECHO   =  C_CDTRECHO  ) AND
                                (CDCLASSE   =  C_CDCLASSE  ) AND
                                (CDPRODUTO  =  C_CDPRODREC ) AND   
                                (DTDECOLVOO =  C_DTDECOLVOO) AND
                                (IDTPPROD   =  C_ORIGEM  );                
                         END IF;      
                
                         V_COUNT_PROD_SUBREC := V_COUNT_PROD_SUBREC + 1; 
                         END LOOP;
                         CLOSE PROD_SUBREC;
          
                         IF V_COUNT_PROD_SUBREC = 0 THEN
                            SELECT CDARVPROD,NMPRODUTO 
                            INTO V_ARVRECORI,V_DESCRECORI 
                            FROM PRODUTO 
                            WHERE CDPRODUTO = C_CDRECEITA;  

                             RAISE_APPLICATION_ERROR( -20502, '?RecSemprod'||V_ARVRECORI||'-'||V_DESCRECORI||'', false);
                             
                             --  Gerao Interrompida. A receita ||V_ARVRECORI||'-'||V_DESCRECOR|| No possui Produtos nem
                             --  receitas em sua composio. Verifique o menu "Ambiente -> Cadastros -> rvore de Receitas"
                             --  e tente novamente.
                         END IF;
          
          
                END LOOP;
                CLOSE C_RECEITAS;
                
                --Enquanto houver receitas na tabela temporria, repete o Loop "While"
                SELECT COUNT(*) 
                INTO V_TESTAREPETE
                --sempre que V_TESTAREPETE > 0, repete o loop
                FROM SERVPREVCONSTMP
                WHERE
                (CDFILIAL   =  C_CDFILIAL  ) AND
                (CDCIA      =  C_CDCIA     ) AND
                (NRVOO      =  C_NRVOO     ) AND
                (CDTRECHO   =  C_CDTRECHO  ) AND
                (CDCLASSE   =  C_CDCLASSE  ) AND
                (DTDECOLVOO =  C_DTDECOLVOO) AND
                (IDTPPROD   =  'R'         );
           
          --Fim do Loop While 
          END LOOP; 
           
        
          IF V_COUNTSUBGRU = 0 THEN
              SELECT CDARVPROD,NMPRODUTO
              INTO V_CDARVSERV,V_DSSERVICO
              FROM PRODUTO
              WHERE
                 CDPRODUTO = C_CDSERVICO;
              
              RAISE_APPLICATION_ERROR( -20502, '?ServSemSubgr'||V_CDARVSERV||'-'||V_DSSERVICO||'', false);
                             --  Gerao Interrompida. O servio ||V_CDARVSERV||'-'||V_DSSERVICO|| No possui nenhum
                             --  subgrupo em sua composio. 
                             --  Verifique o menu "Manual Aprovado -> Manual de Custos Aprovados" e tente novamente.
          END IF;
          
      END LOOP;
      CLOSE C_SERVICO;
            
      
      --------------------------------------------------------------------------
      --  Buscar todos os produtos, com as quantidades somadas (agrupados por
      --  filial) para inserir na tabela de previso de consumo.
      --  O produto apenas  inserido se a quantidade total for maior que zero.
      --------------------------------------------------------------------------     
      OPEN C_PRODUTOS;
      LOOP
         FETCH C_PRODUTOS INTO C_CDFILIAL,C_CDCIA,C_CDPRODUTO,C_QTPRODUTO;
         EXIT WHEN C_PRODUTOS%NOTFOUND;
         
         --Verifica se j existe Previso de consumo para o produto na data
         BEGIN
            SELECT COUNT(*) 
            INTO V_COUNT_PRODUTO
            FROM PREVCONSCOC
            WHERE
               CDFILIAL   = C_CDFILIAL  AND
               CDCIA      = C_CDCIA     AND 
               CDPRODUTO  = C_CDPRODUTO AND
               DTPREVCONS = V_DATA_VOO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_COUNT_PRODUTO := 0;
         END;
         
         --Se a Quantidade prevista for maior que zero e no existir previso para o produto no dia, insere
         IF (C_QTPRODUTO > 0) AND (V_COUNT_PRODUTO = 0) THEN
            INSERT INTO PREVCONSCOC
               (CDFILIAL,CDCIA,CDPRODUTO,DTPREVCONS,QTPREVCONS,DTGERPREVCONS,CDOPERPREVCONS)
            VALUES
               (C_CDFILIAL,C_CDCIA,C_CDPRODUTO,V_DATA_VOO,C_QTPRODUTO,SYSDATE,P_CDOPERPREVCONS);
               
         --Se a Quantidade prevista for maior que zero e j existir previso para o produto no dia, altera 
         ELSIF (C_QTPRODUTO > 0) AND(V_COUNT_PRODUTO > 0) THEN
         
         
               ---------------------------------------------------------------------------
               --       Verifica se j existe Previso de Consumo Aprovada do produto
               --       para a companhia informada
               ---------------------------------------------------------------------------
               SELECT COUNT(*)
               INTO V_CONTA_APROVADA
               FROM PREVCONSCOC
               WHERE
                  (CDFILIAL = C_CDFILIAL  ) AND
                  (IDPREVCONSCOC = 'A'    ) AND
                  (CDPRODUTO = C_CDPRODUTO) AND
                  (DTPREVCONS = V_DATA_VOO) AND
                  (CDCIA      = C_CDCIA   );
            
               --Se j houver previso aprovada na data, no sobrescreve 
               IF V_CONTA_APROVADA = 0 THEN
                   UPDATE PREVCONSCOC
                   SET
                      QTPREVCONS       = C_QTPRODUTO,
                      DTGERPREVCONS    = SYSDATE,
                      CDOPERPREVCONS   = P_CDOPERPREVCONS
                   WHERE                 
                      CDFILIAL   = C_CDFILIAL  AND
                      CDCIA      = C_CDCIA     AND
                      CDPRODUTO  = C_CDPRODUTO AND
                      DTPREVCONS = V_DATA_VOO;      
               END IF;
        --Se a Quantidade prevista for maior igual a zero e no existir previso para o produto no dia, exclui a mesma
         ELSIF (C_QTPRODUTO = 0) AND(V_COUNT_PRODUTO > 0) THEN
             DELETE FROM PREVCONSCOC 
             WHERE 
                CDFILIAL   = C_CDFILIAL  AND
                CDCIA      = C_CDCIA     AND
                CDPRODUTO  = C_CDPRODUTO AND
                DTPREVCONS = V_DATA_VOO;             
         END IF;
         
  
      END LOOP;
      CLOSE C_PRODUTOS;
      
      --Apaga todos os dados da tabela temporria
      DELETE FROM SERVPREVCONSTMP; 
      
    
      --Incrementa 1 dia na data (vai para a prxima data dentro do periodo)
      V_DATA_VOO := V_DATA_VOO + 1; 
  END LOOP;  
  COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('PREVISAO_CONSUMO_COC','4.07.000'); END;
/

