<?php
namespace tests\Zeedhi\Tools\TableImporter;

use Symfony\Component\DependencyInjection\ContainerBuilder;
use Zeedhi\Model\DataBase\Entities\ZhConnection;
use Zeedhi\Model\Util\Environment;
use Zeedhi\Tools\DatabaseReader\DatabaseReader;
use Zeedhi\Tools\TableImporter\TableImporter;

class TableImporterTest extends \PHPUnit_Framework_TestCase {

    /** @var TableImporter */
    protected $tableImporter;
    protected $container;

    protected function setUp() {
        $tablesToImportConnection = \Doctrine\DBAL\DriverManager::getConnection(array(
            'driver'    => 'oci8',
            'user'      => 'USR_ORG_20',
            'password'  => 'teknisa',
            'host'      => '192.168.122.5',
            'port'      => '1521',
            'dbname'    => 'pdborcl',
            'service'   => true
        ));
        $databaseReader = DatabaseReader::factoryFromConnection($tablesToImportConnection);
        $this->tableImporter = new TableImporter($databaseReader);
    }

    public function testImportTablesWithSubModel() {
        $entities = json_decode(file_get_contents(__DIR__."/../../../mocks/entities.json"), true);
        $nrImportedTables = $this->tableImporter->importTablesWithSubModel($entities["subModelsByTables"]);
        $this->assertEquals(5, $nrImportedTables, "Number of imported tables should be 5.");
    }
}
